//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Backpropogation.h"
#include "FuncDisplay.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

float TForm1::sig(float x){
	return (1/(1+exp(-x)))-0.5;
}

float TForm1::sig_diff(float x){
	float s;
	s=sig(x);
	return (1-s)*s;
}

void TForm1::propogate(){
	int x,y;

	//input layer
	for(x=0;x<10;x++){
		layerinp[x]->sum=0;
		for(y=0;y<10;y++){
			layerinp[x]->sum+=layerinp[x]->w[y]*in[y];
		}
		layerinp[x]->out=sig(layerinp[x]->sum);
	}
	//hidden layer
	for(x=0;x<10;x++){
		layermid[x]->sum=0;
		for(y=0;y<10;y++){
			layermid[x]->sum+=layermid[x]->w[y]*layerinp[x]->out;
		}
		layermid[x]->out=sig(layermid[x]->sum);
	}
	//output layer
	for(x=0;x<10;x++){
		layerout[x]->sum=0;
		for(y=0;y<10;y++){
			layerout[x]->sum+=layerout[x]->w[y]*layermid[x]->out;
		}
		layerout[x]->out=sig(layerout[x]->sum);
	}
}

void TForm1::backprop(){
	int x,y;
	//DELTA
	//output layer
	for(x=0;x<10;x++){
		layerout[x]->delta=expectedout[x]-layerout[x]->out;
		layerout[x]->delta*=sig_diff(layerout[x]->sum);
	}
	//hidden layer
	for(x=0;x<10;x++){
		layermid[x]->delta=0;
		for(y=0;y<10;y++){
			layermid[x]->delta+=layerout[y]->w[x]*layerout[y]->delta;
		}
		layermid[x]->delta*=sig_diff(layermid[x]->sum);
	}
	//input layer
	for(x=0;x<10;x++){
		layerinp[x]->delta=0;
		for(y=0;y<10;y++){
			layerinp[x]->delta+=layermid[y]->w[x]*layermid[y]->delta;
		}
        layerinp[x]->delta*=sig_diff(layerinp[x]->sum);
	}
	//CHANGE W
	//input layer
	for(x=0;x<10;x++)for(y=0;y<10;y++){
		layerinp[x]->w[y]+=etha*layerinp[x]->delta*in[y];
	}
	//hidden layer
	for(x=0;x<10;x++)for(y=0;y<10;y++){
		layermid[x]->w[y]+=etha*layermid[x]->delta*layerinp[y]->out;
	}
	//output layer
	for(x=0;x<10;x++)for(y=0;y<10;y++){
		layerout[x]->w[y]+=etha*layerout[x]->delta*layermid[y]->out;
	}
}

void TForm1::display(){
	Form2->Canvas->Pen->Color=0x0000FF;
	for(int x=0;x<10;x++){
		Form2->Canvas->MoveTo(displaypos,x*50+50+layerout[x]->out*50);
		Form2->Canvas->LineTo(displaypos+1,x*50+50+layerout[x]->out*50);
	}
	displaypos++;
}

float TForm1::randweight(){
	float num;
	num=(floor(Random(100)))/1000;
	return num;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner): TForm(Owner){
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	int x,y;
	Edit1->Clear(); Edit2->Clear(); Edit3->Clear(); Edit4->Clear();
	Edit5->Clear(); Edit6->Clear(); Edit7->Clear(); Edit8->Clear();
	Edit9->Clear(); Edit10->Clear(); Edit11->Clear();

	for(x=0;x<10;x++){
		layerinp[x]=new neu();
		layerinp[x]->out=0;
		for(y=0;y<10;y++)layerinp[x]->w[y]=randweight();
	}
	for(x=0;x<10;x++){
		layermid[x]=new neu();
		layermid[x]->out=0;
		for(y=0;y<10;y++)layermid[x]->w[y]=randweight();
	}
	for(x=0;x<10;x++){
		layerout[x]=new neu();
		layerout[x]->out=0;
		for(y=0;y<10;y++)layerout[x]->w[y]=randweight();
	}
	//learning rate
	etha=0.001;
	displaypos=1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	AnsiString s;
	
	s=Edit1->Text;
	for(int x=0;x<10;x++)
		if(x<s.Length()) in[x]=(float)s[x+1]-63;
		else in[x]=0;
	propogate();
	s.printf("%f",layerout[0]->out);
	Edit2->Text=s;
	s.printf("%f",layerout[1]->out);
	Edit3->Text=s;
	s.printf("%f",layerout[2]->out);
	Edit4->Text=s;
	s.printf("%f",layerout[3]->out);
	Edit5->Text=s;
	s.printf("%f",layerout[4]->out);
	Edit6->Text=s;
	s.printf("%f",layerout[5]->out);
	Edit7->Text=s;
	s.printf("%f",layerout[6]->out);
	Edit8->Text=s;
	s.printf("%f",layerout[7]->out);
	Edit9->Text=s;
	s.printf("%f",layerout[8]->out);
	Edit10->Text=s;
	s.printf("%f",layerout[9]->out);
	Edit11->Text=s;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Destroy(TObject *Sender)
{
	int x;
	for(x=0;x<10;x++){delete layerinp[x];}
	for(x=0;x<10;x++){delete layermid[x];}
	for(x=0;x<10;x++){delete layerout[x];}
}
//---------------------------------------------------------------------------

//TRAIN
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	int x,y,z;
	AnsiString s;
//   	Form2->Show();

	for(z=0;z<10000;z++)for(y=0;y<10;y++){
		s=minta[0].inp;
		for(x=0;x<10;x++)
			if(x<s.Length()) in[x]=(float)s[x+1]-63;
			else in[x]=0;
		for(x=0;x<10;x++)expectedout[x]=minta[y].expected[x];
		propogate();
		backprop();
//		display();
	}
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	float in;    
	AnsiString s;
	in=Edit12->Text.ToDouble();
	s.sprintf("%f",sig_diff(in));
	Edit13->Text=s; 	
}
//---------------------------------------------------------------------------

